{------------------------------------------------------------------------------}
{ TWAIN Sample Source                                                          }
{ Copyright (C) '91-'93 TWAIN Working Group:                                   }
{ Aldus, Caere, Eastman-Kodak, Logitech,                                       }
{ Hewlett-Packard Corporations.                                                }
{ All rights reserved.                                                         }
{                                                                              }
{ This source code was converted from C to Turbo Pascal for Windoes by         }
{                                                                              }
{   MCM Design                                                                 }
{   Marc Christopher Martin                                                    }
{   Australiensvej 34                                                          }
{   2100 Copenhagen OE                                                         }
{   Denmark                                                                    }
{                                                                              }
{   e-mail support@mcm-design.dk                                         }
{                                                                              }
{------------------------------------------------------------------------------}

unit MsgBox;

{------------------------------------------------------------------------------}
{$A+} { Align data Byte = $A-, Word = $A+.                                     }
{$F+} { Force FAR call.                                                        }
{$G+} { Generate 80286 code.                                                   }
{$N-} { CoProcessor code generation.                                           }
{$R-} { Range check.                                                           }
{$W-} { Protected mode only $W-, Real mode stack frame support $W+.            }
{$X+} { Extended syntax (When on, function can be used as procedures).         }
{------------------------------------------------------------------------------}

interface

uses WinTypes, WinProcs, Messages{, Objects};


type
  TMSG_BOX_INFO = record
                    lptext     : PChar;
                    lpcaption  : PChar;
                    boxtype    : word;
                    defresp    : word;
                    TimeOutVal : word;
                 end;

  LPMSGBOXINFO = ^TMSG_BOX_INFO;

function TimedMsgBox(hInst      : word{HINSTANCE};
                     hAWnd      : hWnd;
                     lpText     : PChar;
		     lpCaption  : PChar;
                     wBoxType   : word;
                     Def_Resp   : word;
                     TimeOutVal : word) : integer;

function MsgBoxProc(hDlg   : hWnd;
                    Msg    : word;
                    wParam : word;
                    lParam : longint) : bool;

implementation


function TimedMsgBox(hInst      : word{hInstance};
                     hAWnd      : hWnd;
                     lpText     : PChar;
		     lpCaption  : PChar;
                     wBoxType   : word;
                     def_resp   : word;
                     TimeOutVal : word) : integer;
var lpfnMsgBoxProc : TFarProc;
    {$IFDEF WIN32}
      hGlob        : THandle;
    {$ELSE}
      hGlob        : TGlobalHandle;
    {$ENDIF}
    pBoxInfo       : LPMSGBOXINFO;
    RetVal         : integer;

begin
  hGlob := GlobalAlloc(GHND, SizeOf(TMSG_BOX_INFO));
  if (hGlob = 0)
  then begin
       TimedMsgBox := -1;
  end
  else begin
	pBoxInfo := LPMSGBOXINFO(GlobalLock(hGlob));
	pBoxInfo^.lptext     := lpText;
	pBoxInfo^.lpcaption  := lpCaption;
	pBoxInfo^.boxtype    := wBoxType;
	pBoxInfo^.defresp    := def_resp;
	pBoxInfo^.TimeOutVal := TimeOutVal;
	GlobalUnlock(hGlob);

	lpfnMsgBoxProc := MakeProcInstance(@MsgBoxProc, hInst);
	RetVal := DialogBoxParam(hInst,
                                 'TimedMsgBoxDummy',
                                 hAWnd,
                                 lpfnMsgBoxProc,
                                 longint(hGlob));
	FreeProcInstance(lpfnMsgBoxProc);

	GlobalFree(hGlob);
	TimedMsgBox := RetVal;
  end;
end; { End TimedMsgBox.                                                        }


function MsgBoxProc(hDlg   : hWnd;
                    Msg    : word;
                    wParam : word;
                    lParam : longint) : bool;
var hAWnd      : hWnd;
    {$IFDEF WIN32}
      hBoxInfo : THandle;
    {$ELSE}
      hBoxInfo : TGlobalHandle;
    {$ENDIF}
    pmBoxInfo  : LPMSGBOXINFO;
    lptext     : PChar;
    lpcaption  : PChar;
    boxtype    : word;
    {$IFDEF VER70}
      Result   : bool;
    {$ENDIF}
begin
  case Msg of
  WM_INITDIALOG : begin
                    {$IFDEF WIN32}
		      hBoxInfo := THandle(lParam);
                    {$ELSE}
		      hBoxInfo := TGlobalHandle(lParam);
                    {$ENDIF}
		    if Not(SetProp(hDlg, 'MSGBOXDATA', hBoxInfo))
		    then begin
		         EndDialog(hDlg,-1);
			 Result := False;
		    end
                    else begin
		         pmBoxInfo := LPMSGBOXINFO(GlobalLock(hBoxInfo));
		         lptext    := pmBoxInfo^.lptext;
		         lpcaption := pmBoxInfo^.lpcaption;
		         boxtype   := pmBoxInfo^.boxtype;

		         ShowWindow(hDlg, SW_HIDE);
		         if (pmBoxInfo^.TimeOutVal <> 0)
		         then pmBoxInfo^.TimeOutVal := SetTimer(hDlg,
                                                                pmBoxInfo^.defresp,
                                                                pmBoxInfo^.TimeOutVal,
                                                                Nil);

		         GlobalUnlock(hBoxInfo);
		         EndDialog(hDlg, MessageBox(hDlg, lptext, lpcaption, boxtype));
                         Result := True;
                    end;
                  end;
  WM_TIMER      : begin
		    hBoxInfo := GetProp(hDlg, 'MSGBOXDATA');
		    if(hBoxInfo <> 0)
		    then begin
		         pmBoxInfo := LPMSGBOXINFO(GlobalLock(hBoxInfo));
			 lpcaption := pmBoxInfo^.lpcaption;
			 GlobalUnlock(hBoxInfo);
                         hAWnd := FindWindow(PChar(#32770), lpcaption);
			 if (hAWnd <> 0)
			 then EndDialog(hAWnd, integer(wParam));
		    end;
		    Result := True;
                  end;
  WM_DESTROY    : begin
		    hBoxInfo := GetProp(hDlg, 'MSGBOXDATA');
		    if (hBoxInfo <> 0)
		    then begin
		         pmBoxInfo := LPMSGBOXINFO(GlobalLock(hBoxInfo));
			 if (pmBoxInfo^.TimeOutVal <> 0)
			 then KillTimer(hDlg, pmBoxInfo^.TimeOutVal);
			 GlobalUnlock(hBoxInfo);
		    end;
		    Result := False;
                  end;
  else            begin
                    Result := False;
                  end;
  end;
  MsgBoxProc := Result;
end; { End MsgBoxProc.                                                         }


end. { End Unit MsgBox.                                                        }
